(function ($, owner) {
//     owner.APP_DOMAIN = 'https://mbap.jxhrss.gov.cn/whmstr-h5-api-web/f';//测试
    owner.APP_DOMAIN = 'https://mobile.jxhrss.gov.cn/whmstr-h5-api-web/f';//正式



//    owner.APP_DOMAIN = 'http://192.168.10.134:9000/whmstr-h5-api-web/f';//公司测试
//    owner.APP_DOMAIN = 'http://192.168.20.159:9000/whmstr-h5-api-web/f';//测试
    /**
     * 校验手机号码
     * @param mobile
     */
    owner.checkMobile = function (mobile) {
        var length = mobile.length;
        // var re = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1})|(14[0-9]{1}))+\d{8})$/;
        // return length == 11 && re.test(mobile);
        return length == 11 && owner.phone(mobile);
    };

    owner.phone = function istel(tel) {
        var rtn = false;
        //移动号段
        var regtel = /^((13[4-9])|(15([0-2]|[7-9]))|(18[2|3|4|7|8])|(178)|(147))[\d]{8}$/;
        if (regtel.test(tel)) {
            rtn = true;
        }
        //电信号段
        regtel = /^((133)|(153)|(18[0|1|9])|(177))[\d]{8}$/;
        if (regtel.test(tel)) {
            rtn = true;
        }
        //联通号段
        regtel = /^((13[0-2])|(145)|(15[5-6])|(176)|(18[5-6]))[\d]{8}$/;
        if (regtel.test(tel)) {
            rtn = true;
        }
        return rtn;
    };


    /**
     * 校验身份证号
     * @param idCardNo
     */
    owner.checkIdCardNo = function (idCardNo) {
        return idCardNoUtil.checkIdCardNo(idCardNo);
    }

    /**
     * 校验密码  6-20位数字字母_-
     * @param password
     */
    owner.checkPassword = function (password) {
        var re = /^([a-zA-Z0-9]|[._]){6,20}$/;
        return re.test(password);
    }

    owner.checkStrMaxLength = function (strVal, strLength) {
        return strUtil.checkStrMaxLength(strVal, strLength);
    }

    owner.checkStrMinLength = function (strVal, strLength) {
        return strUtil.checkStrMinLength(strVal, strLength);
    }

    var strUtil = {
        getStrLength: function (val) {
            var len = 0;
            for (var i = 0; i < val.length; i++) {
                var a = val.charAt(i);
                if (a.match(/[^\x00-\xff]/ig) != null) {
                    len += 2;
                } else {
                    len += 1;
                }
            }
            return len;
        },
        checkStrMinLength: function (strVal, strLength) {
            var len = strUtil.getStrLength(strVal);
            if (len >= strLength) {
                return true;
            } else {
                return false;
            }
        },
        checkStrMaxLength: function (strVal, strLength) {
            var len = strUtil.getStrLength(strVal);
            if (len <= strLength) {
                return true;
            } else {
                return false;
            }
        }
    }
    var idCardNoUtil = {
        provinceAndCitys: {
            11: "北京",
            12: "天津",
            13: "河北",
            14: "山西",
            15: "内蒙古",
            21: "辽宁",
            22: "吉林",
            23: "黑龙江",
            31: "上海",
            32: "江苏",
            33: "浙江",
            34: "安徽",
            35: "福建",
            36: "江西",
            37: "山东",
            41: "河南",
            42: "湖北",
            43: "湖南",
            44: "广东",
            45: "广西",
            46: "海南",
            50: "重庆",
            51: "四川",
            52: "贵州",
            53: "云南",
            54: "西藏",
            61: "陕西",
            62: "甘肃",
            63: "青海",
            64: "宁夏",
            65: "新疆",
            71: "台湾",
            81: "香港",
            82: "澳门",
            91: "国外"
        },

        powers: ["7", "9", "10", "5", "8", "4", "2", "1", "6", "3", "7", "9", "10", "5", "8", "4", "2"],

        parityBit: ["1", "0", "X", "9", "8", "7", "6", "5", "4", "3", "2"],

        genders: {male: "男", female: "女"},

        checkAddressCode: function (addressCode) {
            var check = /^[1-9]\d{5}$/.test(addressCode);
            if (!check) return false;
            if (idCardNoUtil.provinceAndCitys[parseInt(addressCode.substring(0, 2))]) {
                return true;
            } else {
                return false;
            }
        },

        checkBirthDayCode: function (birDayCode) {
            var check = /^[1-9]\d{3}((0[1-9])|(1[0-2]))((0[1-9])|([1-2][0-9])|(3[0-1]))$/.test(birDayCode);
            if (!check) return false;
            var yyyy = parseInt(birDayCode.substring(0, 4), 10);
            var mm = parseInt(birDayCode.substring(4, 6), 10);
            var dd = parseInt(birDayCode.substring(6), 10);
            var xdata = new Date(yyyy, mm - 1, dd);
            if (xdata > new Date()) {
                return false;//生日不能大于当前日期
            } else if ((xdata.getFullYear() == yyyy) && (xdata.getMonth() == mm - 1) && (xdata.getDate() == dd)) {
                return true;
            } else {
                return false;
            }
        },

        getParityBit: function (idCardNo) {
            var id17 = idCardNo.substring(0, 17);
            var power = 0;
            for (var i = 0; i < 17; i++) {
                power += parseInt(id17.charAt(i), 10) * parseInt(idCardNoUtil.powers[i]);
            }
            var mod = power % 11;
            return idCardNoUtil.parityBit[mod];
        },

        checkParityBit: function (idCardNo) {
            var parityBit = idCardNo.charAt(17).toUpperCase();
            if (idCardNoUtil.getParityBit(idCardNo) == parityBit) {
                return true;
            } else {
                return false;
            }
        },

        checkIdCardNo: function (idCardNo) {
            //15位和18位身份证号码的基本校验
            var check = /^\d{15}|(\d{17}(\d|x|X))$/.test(idCardNo);
            if (!check) return false;

            //判断长度为15位或18位
            if (idCardNo.length == 15) {
                return idCardNoUtil.check15IdCardNo(idCardNo);
            } else if (idCardNo.length == 18) {
                return idCardNoUtil.check18IdCardNo(idCardNo);
            } else {
                return false;
            }
        },

        //校验15位的身份证号码
        check15IdCardNo: function (idCardNo) {
            //15位身份证号码的基本校验
            var check = /^[1-9]\d{7}((0[1-9])|(1[0-2]))((0[1-9])|([1-2][0-9])|(3[0-1]))\d{3}$/.test(idCardNo);
            if (!check) return false;
            //校验地址码
            var addressCode = idCardNo.substring(0, 6);
            check = idCardNoUtil.checkAddressCode(addressCode);
            if (!check) return false;
            var birDayCode = '19' + idCardNo.substring(6, 12);
            //校验日期码
            return idCardNoUtil.checkBirthDayCode(birDayCode);
        },

        //校验18位的身份证号码
        check18IdCardNo: function (idCardNo) {
            //18位身份证号码的基本格式校验
            var check = /^[1-9]\d{5}[1-9]\d{3}((0[1-9])|(1[0-2]))((0[1-9])|([1-2][0-9])|(3[0-1]))\d{3}(\d|x|X)$/.test(idCardNo);
            if (!check) return false;

            //校验地址码
            var addressCode = idCardNo.substring(0, 6);
            check = idCardNoUtil.checkAddressCode(addressCode);
            if (!check) return false;

            //校验日期码
            var birDayCode = idCardNo.substring(6, 14);
            check = idCardNoUtil.checkBirthDayCode(birDayCode);
            if (!check) return false;

            //验证校检码
            return idCardNoUtil.checkParityBit(idCardNo);
        },
        formateDateCN: function (day) {
            var yyyy = day.substring(0, 4);
            var mm = day.substring(4, 6);
            var dd = day.substring(6);
            return yyyy + '-' + mm + '-' + dd;
        }
    }

    function _extends() {
        _extends = Object.assign || function (target) {
            for (var i = 1; i < arguments.length; i++) {
                var source = arguments[i];
                for (var key in source) {
                    if (Object.prototype.hasOwnProperty.call(source, key)) {
                        target[key] = source[key];
                    }
                }
            }
            return target;
        };
        return _extends.apply(this, arguments);
    }

    ajaxCount = {};
    var count = 0;
    Object.defineProperty(ajaxCount, 'count', {
        get: function () {
            return count;
        },
        set: function (newVal) {
            count = newVal < 0 ? 0 : newVal;
            if (mui.showLoading && mui.hideLoading) {
                mui[count ? 'showLoading' : 'hideLoading']("正在加载..", "div");
            }
        }
    });

    /**
     * mui ajax封装
     * @param url, data, type, success,errcallback
     */
    var ajaxCount = {}, count = 0;
    Object.defineProperty(ajaxCount, 'count', {
        get: function () {
            return count;
        },
        set: function (newVal) {
            count = newVal < 0 ? 0 : newVal;
            if (mui.showLoading && mui.hideLoading) {
                mui[count ? 'showLoading' : 'hideLoading']("正在加载..", "div");
            }
        }
    });

    owner.ajax = function (url, data, type, callback, errcallback, async) {
        var headers = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : {};

        var _this = this;

        var type = type || 'get';

        if (async != true && async != false) {
            async = true;
        }

        _extends(headers, {
            'Content-Type': 'application/json',
            'APP-TOKEN': _this.getToken()
        });
        $.ajax({
            type: type,
            url: url,
            data: data,
            timeout: 60000,
            //			  contentType:'application/json',
            headers: headers,
            async: async,
            beforeSend: function beforeSend() {
                ajaxCount.count++;
            },
            success: function success(res) {
                //先判断code的值
                if (res.code) {
                    if (res.code == 500) {
                        // mui.toast(res.msg,{ duration:'long', type:'div' });
                        mui.toast(res.msg); // console.log("我是错误");
                        if (errcallback)
                            errcallback(res);
                    } else if (res.code == 401) {
                        //跳转到登录
                        reLogin();
                    }
                } else if (res.returnCode) {
                    if (res.returnCode == 500) {
                        mui.toast(res.returnMsg);
                        if (errcallback)
                            errcallback(res);
                    } else if (res.responseStatus != undefined && res.responseStatus == 401) {
                        //跳转到登录
                        reLogin();
                    } else {
                        //判断成功的值
                        callback(res);
                    }
                } else {
                    callback(res);
                }
            },
            error: function error(res) {
                //异常处理；
                if (errcallback) {
                    errcallback(res);
                }
            },
            complete: function complete(res) {
                ajaxCount.count--;
            }
        });
    };

    /**
     * 获取格式化之后的时间 2018-10-23 20:52:40
     * @param {Object} date
     */
    owner.getNowFormatDate = function (date) {
        var date = new Date();
        var seperator1 = "-";
        var seperator2 = ":";
        var month = date.getMonth() + 1;
        var strDate = date.getDate();
        if (month >= 1 && month <= 9) {
            month = "0" + month;
        }
        if (strDate >= 0 && strDate <= 9) {
            strDate = "0" + strDate;
        }
        var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate +
            " " + date.getHours() + seperator2 + date.getMinutes() +
            seperator2 + date.getSeconds();
        return currentdate;
    }

    /**
     * artTemplate 日期格式化
     * @param date
     * @param format
     */
    if (typeof template != 'undefined') {
        template.helper('dateFormat', function (date, format) {
            if (!date) {
                return "";
            }
            var length = date.toString().length;
            var pattern, replaceStr;
            switch (length) {
                case 4:
                    pattern = /(\d{4})/;
                    replaceStr = '$1';
                    break;
                case 6:
                    pattern = /(\d{4})(\d{2})/;
                    replaceStr = '$1-$2';
                    break;
                case 8:
                    pattern = /(\d{4})(\d{2})(\d{2})/;
                    replaceStr = '$1-$2-$3';
                    break;
                case 10:
                    pattern = /(\d{4})(\d{2})(\d{2})(\d{2})/;
                    replaceStr = '$1-$2-$3 $4';
                    break;
                case 12:
                    pattern = /(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})/;
                    replaceStr = '$1-$2-$3 $4:$5';
                    break;
                case 14:
                    pattern = /(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
                    replaceStr = '$1-$2-$3 $4:$5:$6';
                    break;
                default:
                    mui.toast('日期格式不正确，请检查！');
                    return;
            }

            var dateStr = date.toString().replace(pattern, replaceStr);
            date = new Date(dateStr.replace(/\s/g, 'T').replace(/\//g, '-'));
            var map = {
                "M": date.getMonth() + 1,//月份
                "d": date.getDate(),//日
                "h": date.getHours(),//小时
                "m": date.getMinutes(),//分
                "s": date.getSeconds(),//秒
                "q": Math.floor((date.getMonth() + 3) / 3),//季度
                "S": date.getMilliseconds()//毫秒
            };
            format = format.replace(/([yMdhmsqS])+/g, function (all, t) {
                var v = map[t];
                if (v !== undefined) {
                    if (all.length > 1) {
                        v = '0' + v;
                        v = v.substr(v.length - 2);
                    }
                    return v;
                } else if (t === 'y') {
                    return (date.getFullYear() + '').substr(4 - all.length);
                }
                return all;
            });
            return format;
        });

        //金额格式化
        template.helper('priceFormat', function (price, type) {
            if (price) {
                var arrayPrice = price.toString().split(".");
                if (type == 'integer') {
                    return arrayPrice[0] ? arrayPrice[0] : "0";
                } else if (type == 'decimal') {
                    // return arrayPrice[1]?arrayPrice[1].length == 1?"."+arrayPrice[1]+"0":"."+arrayPrice[1]:"0.00";
                    var num = price.toFixed(2);
                    num = num.toLocaleString();
                    return num;
                }
            } else {
                if (type == 'integer') {
                    return "0";
                } else if (type == 'decimal') {
                    return "0.00";
                }
            }
        });
    }


    //重新登录
    function reLogin() {
        owner.clearToken();
        if (window.mobileError)
            window.mobileError.tokenError("401");
        if (window.webkit)
            window.webkit.messageHandlers.collectSendKey.postMessage({body: "401"});
    }

    //判断是否有token
    owner.hasToken = function () {
        var token = sessionStorage.getItem("token") || this.getCookie("token");
        var isLogin = true;
        app.ajax(app.APP_DOMAIN+'/ucenter/getUserInfo', '', 'get', function (res) {
            console.info("res.returnCode："+res.returnCode)
            if(res.returnCode=='0000'){
                isLogin = true;
            } else {
                isLogin = false;
                // mui.toast(res.returnMsg);
            }
        }, function (res) {
            isLogin = false;
        }, false);
        if (!token || token.length > 64 || !isLogin) {
            //重新登录
            reLogin();
            return false;
        } else {
            return true
        }
    };

    /**
     *
     * @param {URIString} target 需要打开的页面的地址
     * @param {Object} parm  传递的对象
     * @param {Boolean} autoShow  是否自动显示
     */
    owner.openWindow = function (target, id, autoShow) {
        mui.openWindow({
            url: target,
            id: id,
            show: {
                autoShow: autoShow, //页面loaded事件发生后自动显示，默认为true
                aniShow: 'pop-in',
                duration: 200
            },
            waiting: {
                autoShow: true
                // options: waitingStyle
            },
            extras: {
                info: ""
            }
        })
    }
    owner.getQueryString = function (name) {
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        if (r != null) return unescape(r[2]);
        return null;
    }

    /**
     *
     */
    owner.getToken = function () {
        var token = sessionStorage.getItem("token");
        // if(!token|| token.length>64){
        //     //重新登录
        //     reLogin();
        // }else{
        //     return token;
        // }
        return token;
    }
    /**
     *
     */
    owner.saveToken = function (token) {
        sessionStorage.setItem("token", token);
    }
    owner.clearToken = function () {
        sessionStorage.removeItem("token");
    }
    owner.saveSessionItem = function (key, value) {
        sessionStorage.setItem(key, value);
    }
    owner.clearSessionItem = function (key) {
        sessionStorage.removeItem(key);
    }
    /**
     * 根据key获取cookie中的value
     */
    owner.getCookie = function (key) {
        var arr, reg = RegExp('(^| )' + key + '=([^;]+)(;|$)');
        if (arr = document.cookie.match(reg))    //["username=liuwei;", "", "liuwei", ";"]
            return decodeURIComponent(arr[2]);
        else
            return null;
    }

    /**
     * 根据key删除cookie中的value
     */
    owner.delCookie = function (key) {
        var _this = this, date = new Date();
        date.setTime(date.getTime() - 1);
        var delValue = _this.getCookie(key);
        if (!!delValue) {
            document.cookie = key + '=' + delValue + ';expires=' + date.toGMTString();
        }
    }

    owner.rsCode = {
        "renYuan": 'SI0020', //人员信息查询
        "canBao": 'SI0022', //参保查询
        "mIAccount": 'SI0024', //账户余额查询
        "payFee": 'SI0028', //社保缴费查询
        "eIAccount": 'SI0023', //账户养老账户查询
        "differentPlaceAnZhi": 'SI0027', //异地安置查询
        "chronicDisease": 'SI0025', //慢性疾病审批查询
        "bXSchedule": 'SI0039', //医保报销进度查询
        "SIPQ01": 'SIPQ01', //医保目录查询
        "publicQuery": 'SI0040', //定点医疗机构查询
        "SIPQ02": 'SIPQ02',
        "expense": 'SI0029', //医疗费用查询
        //企业养老待遇领取估算
        "qyylEstimateThe":"SI0090"
    }

    owner.getFullYear = function (date) {
        var year = date.getFullYear();
        return year.toString();
    };
    owner.getMonth = function (date) {
        var month = date.getMonth() + 1;
        month = (month < 10 ? "0" + month : month);
        return month.toString();
    };

    owner.addDate = function (interval, number, date) {
        // var date = new Date;
        switch (interval) {
            case "Y": {
                date.setFullYear(date.getFullYear() + number);
                return date;
                break;
            }
            case "Q": {
                date.setMonth(date.getMonth() + number * 3);
                return date;
                break;
            }
            case "M": {
                date.setMonth(date.getMonth() + number);
                return date;
                break;
            }
            case "W": {
                date.setDate(date.getDate() + number * 7);
                return date;
                break;
            }
            case "D": {
                date.setDate(date.getDate() + number);
                return date;
                break;
            }
            case "h": {
                date.setHours(date.getHours() + number);
                return date;
                break;
            }
            case "m": {
                date.setMinutes(date.getMinutes() + number);
                return date;
                break;
            }
            case "s": {
                date.setSeconds(date.getSeconds() + number);
                return date;
                break;
            }
            default: {
                date.setDate(d.getDate() + number);
                return date;
                break;
            }
        }
    }
    owner.nullInfo = function () {
        return "<div class=\"null-info\">\n" +
            "    <div class=\"null-images\"></div>\n" +
            "    <div class=\"null-txt\">没有查询到你要的信息</div>\n" +
            "</div>"
    }
    owner.nullInfoTop15 = function () {
        return "<div class=\"null-info15\">\n" +
            "    <div class=\"null-images\"></div>\n" +
            "    <div class=\"null-txt\">没有查询到你要的信息</div>\n" +
            "</div>"
    }
    owner.nullInfoTop45 = function () {
        return "<div class=\"null-info45\">\n" +
            "    <div class=\"null-images\"></div>\n" +
            "    <div class=\"null-txt\">没有查询到你要的信息</div>\n" +
            "</div>"
    }
    owner.removeNullInfo = function () {
        var nullObj = Zepto(".null-info");
        if (nullObj) {
            nullObj.remove();
        }
    }
    owner.removeNullInfoTop15 = function () {
        var nullObj = Zepto(".null-info15");
        if (nullObj) {
            nullObj.remove();
        }
    }
    owner.removeNullInfoTop45 = function () {
        var nullObj = Zepto(".null-info45");
        if (nullObj) {
            nullObj.remove();
        }
    }

    owner.callRefreshMui = function (id, isOver) {
        mui('#' + id).pullRefresh().endPullupToRefresh(isOver); //参数为true代表没有更多数据了。
    }

    function initToken() {
        var token = owner.getQueryString("token");
        // var token = c8819486b212489a800762dc3fce8adc;
        //缓存token
        if (!owner.getToken()) {
            owner.saveToken(token);
        }
    }

    owner.EthnicGroups = [{
        "text": "汉族",
        "value": "01"
    }, {
        "text": "蒙古族",
        "value": "02"
    }, {
        "text": "回族",
        "value": "03"
    }, {
        "text": "藏族",
        "value": "04"
    }, {
        "text": "维吾尔族",
        "value": "05"
    }, {
        "text": "苗族",
        "value": "06"
    }, {
        "text": "彝族",
        "value": "07"
    }, {
        "text": "壮族",
        "value": "08"
    }, {
        "text": "布依族",
        "value": "09"
    }, {
        "text": "朝鲜族",
        "value": "10"
    }, {
        "text": "满族",
        "value": "11"
    }, {
        "text": "侗族",
        "value": "12"
    }, {
        "text": "瑶族",
        "value": "13"
    }, {
        "text": "白族",
        "value": "14"
    }, {
        "text": "土家族",
        "value": "15"
    }, {
        "text": "哈尼族",
        "value": "16"
    }, {
        "text": "哈萨克族",
        "value": "17"
    }, {
        "text": "傣族",
        "value": "18"
    }, {
        "text": "黎族",
        "value": "19"
    }, {
        "text": "僳僳族",
        "value": "20"
    }, {
        "text": "佤族",
        "value": "21"
    }, {
        "text": "畲族",
        "value": "22"
    }, {
        "text": "高山族",
        "value": "23"
    }, {
        "text": "拉祜族",
        "value": "24"
    }, {
        "text": "水族",
        "value": "25"
    }, {
        "text": "东乡族",
        "value": "26"
    }, {
        "text": "纳西族",
        "value": "27"
    }, {
        "text": "景颇族",
        "value": "28"
    }, {
        "text": "柯尔克孜族",
        "value": "29"
    }, {
        "text": "土族",
        "value": "30"
    }, {
        "text": "达斡尔族",
        "value": "31"
    }, {
        "text": "仫佬族",
        "value": "32"
    }, {
        "text": "羌族",
        "value": "33"
    }, {
        "text": "布朗族",
        "value": "34"
    }, {
        "text": "撒拉族",
        "value": "35"
    }, {
        "text": "毛难族",
        "value": "36"
    }, {
        "text": "仡佬族",
        "value": "37"
    }, {
        "text": "锡伯族",
        "value": "38"
    }, {
        "text": "阿昌族",
        "value": "39"
    }, {
        "text": "普米族",
        "value": "40"
    }, {
        "text": "塔吉克族",
        "value": "41"
    }, {
        "text": "怒族",
        "value": "42"
    }, {
        "text": "乌孜别克族",
        "value": "43"
    }, {
        "text": "俄罗斯族",
        "value": "44"
    }, {
        "text": "鄂温克族",
        "value": "45"
    }, {
        "text": "德昂族",
        "value": "46"
    }, {
        "text": "保安族",
        "value": "47"
    }, {
        "text": "裕固族",
        "value": "48"
    }, {
        "text": "京族",
        "value": "49"
    }, {
        "text": "塔塔尔族",
        "value": "50"
    }, {
        "text": "独龙族",
        "value": "51"
    }, {
        "text": "鄂伦春族",
        "value": "52"
    }, {
        "text": "赫哲族",
        "value": "53"
    }, {
        "text": "门巴族",
        "value": "54"
    }, {
        "text": "珞巴族",
        "value": "55"
    }, {
        "text": "基诺族",
        "value": "56"
    }, {
        "text": "穿青人",
        "value": "57"
    }];
    //初始化token信息
    initToken();
}(mui, window.app = {}));