(function($, owner,document) {
	
	//初始化
	owner.init = function(){
		var self = this;
		self.data={};
		self.data.uuid = window.sessionStorage.getItem("uuid");
		$.init();
		self.addEvents();
	}
	
	//校验
	owner.validate = function(password,confirm){
		if(password == null || password == ""){
	    	mui.alert('请输入密码');
	    	return false;
	    }
		if(!app.checkPassword(password)){
	    	mui.alert('请输入6-20位包含数字字母_-,至少由数字和字母组成的密码');
	    	return false;
	    }
		if(confirm!==password){
			mui.alert('两次输入的密码不一致,重新输入');
	    	return false;
		}
		return true;
	}
	
	//绑定事件
	owner.addEvents = function(){
		var self = this;
		//提交
		mui(".mui-content").on('tap','#submit',function(){
			var password = document.getElementById("password").value;
			var confirm = document.getElementById("confirm").value;
			if(!self.validate(password,confirm)){
				return false;
			}
			var paramsObj = {
					UUID:self.data.uuid,
					password:password
			};
			app.ajax(app.APP_DOMAIN+'/registerApi/saveUserInfo',JSON.stringify(paramsObj),'post',function (res) {
	        	if(res.responseStatus == '200'){
	        		mui.alert('系统提示', '注册成功!', function() {
	        			//跳转到登录页面
		            	app.openWindow(app.APP_DOMAIN+'/login','login',true);
	                });
	        	}else{
					$.toast(res.errorMessage);
				}
	        },function (res) {
	        	console.log(res,'失败返回的串');
	        });
         });
	}
	
	
	
}(mui, window.password = {},document));

password.init();
