(function ($, owner) {
    var CURRENT_PAGE = 1, PAGE_COUNT = 20, isInit = true, isOver = false;
    //初始化
    owner.init = function () {
        var _this = this;
    }

    //渲染页面
    owner.render = function (targetId, sourceId, key, value) {
        var _this = this,
            data = {};
        data[key] = value;
        //渲染数据到页面
        Zepto("#" + targetId).html(template(sourceId, data));
    }

    //养老账户余额查询
    owner.getEIAccount = function () {
        var _this = this;
        var EIAccount = [];
        var dataObj = {};
        dataObj["CURRENT_PAGE"] = CURRENT_PAGE;
        dataObj["PAGE_COUNT"] = PAGE_COUNT;
        dataObj["AAB301"] = 'jg';
        app.removeNullInfo();
        app.ajax(app.APP_DOMAIN + '/eIAccount/' + app.rsCode.eIAccount, JSON.stringify(dataObj), 'post', function (res) {
            var returnCode = res.returnCode;

            if (returnCode == '0000') {
                if (!res.resultData || !res.resultData["total_count"] || res.resultData["total_count"] == 0) {
                    Zepto(".nullInfo").append(app.nullInfo());
                } else {
                    EIAccount = res.resultData;
                    //单独赋值真是姓名
                    EIAccount.realname = res.realname;
                    if (EIAccount.jsonlist.length < PAGE_COUNT) {
                        isOver = true;
                    }
                    //调用模板渲染数据到页面
                    if (isInit) {
                        isInit = false;
                        _this.render('header_view', 'header_script', 'EIAccount', EIAccount);
                        _this.render('body_view', 'body_script', 'EIAccount', EIAccount);
                        _this.render('remark_view', 'remark_script', 'EIAccount', EIAccount);

                    } else {
                        var data = {};
                        data.EIAccount = EIAccount;

                        var html = template('body_script', data);
                        document.getElementById("body_view").innerHTML += html;
                    }
                    //当前页数加加
                    if (isOver == false) {
                        CURRENT_PAGE++;
                    }
                    Zepto(".table").removeClass("mui-hidden");
                    initHeight();
                }
            } else {
                Zepto(".nullInfo").append(app.nullInfo());
                mui.toast(res.returnMsg);
            }
            callRefresh();
        }, function () {
            callRefresh();
            Zepto(".nullInfo").append(app.nullInfo());
        });
    }

    //上拉加载
    mui.init({
        pullRefresh: {
            container: '#pullrefresh',
            up: {
                auto: true,
                contentrefresh: '正在加载...',
                callback: pullupRefresh
            }
        }
    });

    function pullupRefresh() {
        setTimeout(function () {
            if (!isOver) {
                owner.getEIAccount();//参数为true代表没有更多数据了。
            }
        }, 1500);
    }

    function callRefresh() {
        app.callRefreshMui('pullrefresh', isOver);
    }

    //计算高度
    function initHeight() {
        var headHeight,tabHeight;
        var tab = document.getElementById("tab");
        if (!tab) {
            tabHeight = 0;
        } else {
            tabHeight = document.getElementById("tab").offsetHeight;
        }
        var thead = document.getElementById("thead");
        if (!thead) {
            headHeight = 5;
        } else {
            headHeight = document.getElementById("thead").offsetHeight + 5;
        }
        //计算header_view的高度
        var height = document.getElementById("header_view").offsetHeight + headHeight+tabHeight;

        document.getElementById("pullrefresh").style.top = height + "px";
        document.getElementById("pullrefresh").style.bottom = (document.querySelector(".remark-content").offsetHeight+16)+"px";
    }

}(mui, window.account = {}));
//判断是否登陆
if (app.hasToken()) {
    account.init();
}
