(function ($, owner) {
    var CURRENT_PAGE = 1, PAGE_COUNT = 20, TYPE = '1', isInit = true;
    //初始化
    owner.init = function () {
        var _this = this;
        _this.getDifferentPlace();
    }

    //渲染页面
    owner.render = function (targetId, sourceId, key, value) {
        var _this = this,
            data = {};
        data[key] = value;
        //渲染数据到页面
        Zepto("#" + targetId).html(template(sourceId, data));
    };

    //转诊转院信息查询
    owner.getDifferentPlace = function () {
        app.removeNullInfo();
        var differentPlaceObj = {}, _this = this;
        differentPlaceObj["CURRENT_PAGE"] = CURRENT_PAGE;
        differentPlaceObj["PAGE_COUNT"] = PAGE_COUNT;
        app.ajax(app.APP_DOMAIN + '/differentPlaceAnZhi/SI0041', JSON.stringify(differentPlaceObj), 'post', function (res) {
            if (res.returnCode == '0000') {
                if (!res.resultData || !res.resultData.jsonlist || res.resultData.jsonlist.length == 0) {
                    Zepto(".nullInfo").append(app.nullInfo());
                } else {
                    var list = res.resultData.jsonlist;
                    //调用模板渲染数据到页面
                    _this.render('content_view', 'content_script', 'list', list);
                    //当前页数加加
                    // CURRENT_PAGE++;
                }
            } else {
                Zepto(".nullInfo").append(app.nullInfo());
                mui.toast(res.returnMsg);
            }
        }, function () {
            Zepto(".nullInfo").append(app.nullInfo());
        });

    };
}(mui, window.transferHospital = {}));
//判断是否登陆
if (app.hasToken()) {
    transferHospital.init();
}