(function($, owner) {
	//初始化
    owner.init = function(){
        var _this = this;
        //初始化数据
        _this.getPublicQuery();
    }

    //渲染页面
    owner.render = function(targetId,sourceId,key,value){
        var _this = this,
            data = {};
        data[key] = value;
        //渲染数据到页面
        Zepto("."+targetId).html(template(sourceId,data));
    }

	//异地安置查询
	owner.getPublicQuery = function() {
        var _this = this;
        var list = [];
        var dataObj = {};
        app.removeNullInfo();
        app.ajax(app.APP_DOMAIN+'/differentPlaceAnZhi/'+app.rsCode.differentPlaceAnZhi, JSON.stringify(dataObj), 'post', function(res){
            var returnCode = res.returnCode;
            if(returnCode == '0000'){
                if (!res.resultData || !res.resultData.jsonlist||res.resultData.jsonlist.length==0) {
                    Zepto(".nullInfo").append(app.nullInfo())
                } else {
                    list = res.resultData.jsonlist;
                    //调用模板渲染数据到页面
                    _this.render('mui-tableBox','body_script','list',list);
                }
            }else{
                Zepto(".nullInfo").append(app.nullInfo());
                mui.toast(res.returnMsg);
            }
        }, function () {
            Zepto(".nullInfo").append(app.nullInfo());
        });
	}
}(mui, window.differentPlaceAnZhi = {}));
//判断是否登陆
if(app.hasToken()){
	differentPlaceAnZhi.init();
}