(function ($, owner) {
    var AAC006= '',AAC007='',ALA043='',AIC162='',PJGZZZL='',JGYS00='',AAA027='', isInit = true, isOver = false;
    //初始化
    owner.init = function () {
        //初始化数据
        this.addEvent();
    }
	
    owner.addEvent = function () {
    	var _this = this;
    	 //获取退休年龄与计发月数对应数据
    	var yljgsPicker = new $.PopPicker({
			layer: 1
		});
		//退休年龄与计发月数对应数据
		yljgsPicker.setData(jsys00);
		
		
        var dtpicker = new mui.DtPicker(
            {
                type: "month", //设置日历初始视图模式
                beginDate: new Date(1995, "09"), //设置开始日期
                endDate: new Date() //设置结束日期
            }
        );
    	var brithdtpicker = new mui.DtPicker(
            {
                type: "month", //设置日历初始视图模式
                beginDate: new Date(1900, "01"), //设置开始日期
                endDate: new Date() //设置结束日期
            }
        );
		var dtpickerRetired = new mui.DtPicker(
            {
                type: "month", //设置日历初始视图模式
                beginDate: new Date(1900, "01"), //设置开始日期
                endDate: new Date(new Date().getFullYear()+60,"01") //设置结束日期
            }
	    );
	    
	    var dateDt= new Date();
    	var mm = (dateDt.getMonth()+1)<10?mm= "0"+(dateDt.getMonth()+1):(dateDt.getMonth()+1)+"";
    	var selectedValue = dateDt.getFullYear()+"-"+mm;
    	
        mui(".butBox").on('tap', '#estimateTheButton', function () {
            if (_this.validate()) {
                //清空渲染
                clearRenderContent();
				//提交估算数据
                _this.getqyylEstimateThe();
            }
        });
    
        //出生日期选择器
        mui(".mui-content").on('tap', '.selectBrithDt', function () {
        	var self = this;
   			brithdtpicker.setSelectedValue(selectedValue);
            brithdtpicker.show(function (selectItems) {
                Zepto(self).text(selectItems.y.text + "-" + selectItems.m.text);
                Zepto(self).data('date', selectItems.y.text + selectItems.m.text);
                //选择出生日期后，退休日期往后顺延60年
            	var retiredDtTempDt = (parseInt(selectItems.y.text)+60)+selectItems.m.text;  
            	var retiredDtTemp = (parseInt(selectItems.y.text)+60)+"-"+selectItems.m.text;  
			    //60年后
			    Zepto("#retiredDt").data("date", retiredDtTempDt);
			    Zepto("#retiredDt").text(retiredDtTemp);
			    
			    
			    document.getElementById("monthCount").value ="";
		    	//通过计算出退休时的年龄来获取计发月数
            	var RetiredYears = calculationOfMonth(selectItems.y.text + selectItems.m.text,retiredDtTempDt);
            	yljgsPicker.pickers[0].setSelectedValue(RetiredYears,0)
            	var iTems = yljgsPicker.getSelectedItems();
            	if(iTems[0].value == RetiredYears){
 	            	document.getElementById("monthCount").value = iTems[0].text;                
            	}else{
            		mui.toast('未查询到退休年龄所对应的计发月数,请确认出生日期与退休年月选择正确！');
            	}
            });
        });
        //退休日期选择器
		mui(".mui-content").on('tap', '.selectRetiredDt', function () {
			var self = this;
   			dtpickerRetired.setSelectedValue(selectedValue);
            dtpickerRetired.show(function (selectItems) {
                if(!_this.isNull(Zepto("#brithDt").data("date"))){
                	mui.toast('请先选择出生年月');
                }else{
                	 Zepto(self).text(selectItems.y.text + "-" + selectItems.m.text);
                	 Zepto(self).data('date', selectItems.y.text + selectItems.m.text);
                	 
                	document.getElementById("monthCount").value ="";
                	//通过计算出退休时的年龄来获取计发月数
                	var RetiredYears = calculationOfMonth(Zepto("#brithDt").data("date"),selectItems.y.text + selectItems.m.text);
                	yljgsPicker.pickers[0].setSelectedValue(RetiredYears,0)
                	var iTems = yljgsPicker.getSelectedItems();
                	if(iTems[0].value == RetiredYears){
                		document.getElementById("monthCount").value = iTems[0].text;
                	}else{
                		mui.toast('未查询到退休年龄所对应的计发月数,请确认出生日期与退休年月选择正确！');
                	}
                }
            });
        });
        
        
        mui(".mui-content").on('tap', '.selectDt', function () {
        	var self = this;
   			dtpicker.setSelectedValue(selectedValue);
            dtpicker.show(function (selectItems) {
                Zepto(self).text(selectItems.y.text + "-" + selectItems.m.text);
                Zepto(self).data('date', selectItems.y.text + selectItems.m.text);
            });
        });
        //历年实际缴费工资水平
        var listData = [];
        for (var i = 3; i < 31; i++) {
        	temp = i/10;
        	var obj = {value: temp,text: temp};
        	listData.push(obj);
        }
    	var userPicker = new $.PopPicker();
		userPicker.setData(listData);
		mui(".mui-content").on('tap', '.selectWagesLevelDt', function () {
			userPicker.show(function(items) {
		       Zepto("#wagesLevel").text(items[0].text );
               Zepto("#wagesLevel").data('date', items[0].value);
				//返回 false 可以阻止选择框的关闭
				//return false;
			});
		});
		
        //获取参保地地区编码数据
    	var cityPicker = new $.PopPicker({
			layer: 1
		});

		//只取江西省地市级数据
		cityPicker.setData(cityData);
		cityPicker.pickers[0].setSelectedValue("360000", 0);
		cityPicker.setData(cityPicker.getSelectedItems()[0].children);
        //选择参保地
        mui(".mui-content").on('tap', '.selectRegionDt', function () {
			cityPicker.show(function(items) {
				Zepto("#region").data("date", items[0].value);
				Zepto("#region").text(items[0].text);
				//返回 false 可以阻止选择框的关闭
				//return false;
			});
        });
        //全年在岗平均工资增长率   默认8% 前台手工输入
        document.getElementById("wagesGrowthRate").value = "8%";
	}
    //渲染页面
    owner.render = function (targetId, sourceId, key, value) {
        var _this = this,
            data = {};
        data[key] = value;
        // //渲染数据到页面
        Zepto("#" + targetId).html(template(sourceId, data));
    }

    //校验
    owner.validate = function () {
    	var _this = this;
        AAC006 = Zepto("#brithDt").data("date"); //出生年月           根据当前用户身份证号获取
        AAC007 = Zepto("#inJoinDt").data("date");//参加工作年月   前台手工输入
        ALA043 = Zepto("#wagesLevel").data("date");    //本人缴费工资平均指数		范围0.3-3，前台手工输入
        AIC162 = Zepto("#retiredDt").data("date");    //退休年月				前台手工输入
        JGYS00 = document.getElementById("monthCount").value;    //计发月数				前台手工输入
		PJGZZZL=document.getElementById("wagesGrowthRate").value;//全年在岗平均工资增长率	默认8% 前台手工输入
        AAA027 = Zepto("#region").data("date");    //参保地编码   			前台手工输入
        var isOK = true;
        if(!_this.isNull(AAC006)){
        	mui.toast('请选择出生年月');
        	isOK = false;
        }else if(!_this.isNull(AAC007)){
        	mui.toast('请选择参加工作年月');
        	isOK = false;
        }else if(!_this.isNull(ALA043)){
        	mui.toast('请输入缴费工资平均指数');
        	isOK = false;
        }else if(!_this.isNull(AIC162)){
        	mui.toast('请选择退休年月');
        	isOK = false;
        }else if(!_this.isNull(JGYS00)){
        	mui.toast('计发月数不能为空');
        	isOK = false;
        }else if(!_this.isNull(PJGZZZL)){
        	mui.toast('请输入全年在岗平均工资增长率');
        	isOK = false;
        }else if(!_this.isNull(AAA027)){
        	mui.toast('请选择参保地');
			isOK = false;
        }
        return isOK;
    }
    
    //判断是否为空
	 owner.isNull = function (str){
		if (str == null || str == "" || str===undefined || str=="undefined" ) {
            return false;
        }else{
        	 return true;
        }
	}
    //医保报销进度查询
    owner.getqyylEstimateThe = function () {
        var _this = this;
        var list = [];
        var dataObj = {};
        if(PJGZZZL.indexOf('%') != -1){
        	PJGZZZL=PJGZZZL.replace("%","");
        }
        dataObj["AAC006"] = AAC006 ;//出生年月	         	根据当前用户身份证号获取
        dataObj["AAC007"] = AAC007 ;//参加工作年月   			前台手工输入
        dataObj["ALA043"] = ALA043 ;//本人缴费工资平均指数		范围0.3-3，前台手工输入
        dataObj["AIC162"] = AIC162 ;//退休年月				前台手工输入
        dataObj["JGYS00"] = JGYS00 ;//计发月数				前台手工输入
        dataObj["PJGZZZL"] =PJGZZZL;//全年在岗平均工资增长率	默认8% 前台手工输入
        dataObj["AAA027"] = AAA027 ;//参保地编码   			前台手工输入
        app.ajax(app.APP_DOMAIN + '/qyylEstimateThe/' + app.rsCode.qyylEstimateThe, JSON.stringify(dataObj), 'post', function (res) {
            var returnCode = res.returnCode;
            if (returnCode == '0000') {
                if (!res.resultData) {
                    mui.toast(res.returnMsg);
                } else {
                	document.getElementById("header_view_result").hidden="";
					document.getElementById("header_view").hidden="hidden";		
                     // 调用模板进行数据渲染
//                  var data = {'JCYLJ0': '223.5', 'GRZHYLJ': '546.55', 'GDXYLJ': '2458.2', 'aae019': '5555.55'};
//                  var html = template('content_script', data);
                    var html = template('content_script', res.resultData);
                    document.getElementById("header_view_result").innerHTML = html;
               }
            } else {
                mui.toast(res.returnMsg);
            }
        }, function (res) {
			mui.toast(res.returnMsg || "系统异常，请稍后重试");
        });
    }

    //清空内容渲染
    function clearRenderContent() {
        //点击查询清空数据
        Zepto("#content_view").empty();
    }

    //清空没有数据时候的提示
    function clearNoDataAlter() {
        app.removeNullInfoTop15();
    }

}(mui, window.qyylEstimateThe = {}));
//判断是否登陆
if (app.hasToken()) {
    qyylEstimateThe.init();
}

function returnButton(){
	document.getElementById("header_view_result").hidden="hidden";
	document.getElementById("header_view").hidden="";

}
//计算两个时间相差的年数（月数）
function calculationOfMonth(startDate,endDate){
	startDate = startDate+"";
	endDate = endDate+"";
	var result = 0;
//	result = (parseInt(endDate.substring(0,4))-parseInt(startDate.substring(0,4)))*12+parseInt(endDate.substring(4,6))-parseInt(startDate.substring(4,6));
	result = (parseInt(endDate.substring(0,4))-parseInt(startDate.substring(0,4)));
	return result;
}

//失去焦点触发器
$('body').on('keyup blur', '.percentage', function (even) {
    if(even.keyCode>=37&&even.keyCode<=40){
        return false;
    }
    e = $(this);
    var percentage =e.val();
    
    if(percentage.substring(0,1) =="0" && percentage.length>1){
      	percentage = percentage.substring(1,percentage.length);
    }else if(percentage>100){
      	if(percentage.indexOf(".") != -1){
      		percentage = percentage.substr(0,2)+percentage.substr(percentage.indexOf("."),percentage.length)
      	}else{
      		percentage = percentage.substr(0,2);
      	}
    }
    　	percentage = percentage.replace(/[^\d.]/g,""); //清除"数字"和"."以外的字符

        　　percentage = percentage.replace(/^\./g,""); //验证第一个字符是数字而不是.

        　　percentage = percentage.replace(/\.{2,}/g,"."); //只保留第一个. 清除多余的.

        　　percentage = percentage.replace(".","$#$").replace(/\./g,"").replace("$#$",".");//只允许输入一个小数点

        　　percentage = percentage.replace(/^(\-)*(\d+)\.(\d\d).*$/,'$1$2.$3'); //只能输入两个小数

        e.val(percentage);
});

$('body').on('blur', '.percentage', function (even) {
	if(e.val().indexOf("%") == -1){
    	var temp = e.val().replace("%","");
    	if(!temp){
    		temp = 8;
    	}
    	temp = temp+"%";
    	e.val(temp);
    }
});


//获取焦点触发器
$('body').on('focus', '.percentage', function (even) {
    e = $(this);
    e.val(e.val().replace("%",""));
});
