(function($, owner,document) {
	
	//初始化
	owner.init = function(){
		var self = this;
		$.init();
		self.getMyCard();
	}
	
	//渲染页面
    owner.render = function(targetId,sourceId,key,value){
    	var _this = this,
    		data = {};
        data[key] = value;
        //渲染数据到页面
    	Zepto("#"+targetId).html(template(sourceId,data));
    }
	
	
	owner.getMyCard = function(){
		var self = this;
		app.ajax(app.APP_DOMAIN + '/myCard/myCard','', 'get', function(res) {
			if(res.returnCode == '0000') {
				if(res.msgCode == '000000') {
					var cardList = res.result, renderList = [], info = {}, otherChannelSign = false;
					info.name = res.name;
					info.idcard = res.idcard;
					for(var i in cardList) {
						if(cardList[i].signFlag == '1') {//1:已签发，0:未签发，2:其他渠道已签发
							renderList.push(info);
						} else if(cardList[i].signFlag == '2'){
							otherChannelSign = true;
						}
					}
					if(renderList.length > 0) {
						self.render('myCards','card','list', renderList);
					} else if(otherChannelSign){
						mui.alert("查询到您已在其他渠道签发过电子社保卡，若想使用本功能请安装江西人社手机app并重新签发");
					} else {
						mui.alert("您尚未领取电子社保卡，请安装江西人社手机app进行领卡");
					}
				} else {
					mui.alert("查询电子社保卡失败，请稍后再试");
				}
			} else if(res.returnCode=='401'){
				mui.toast(res.returnMsg);
			} else {
				mui.toast(res.msg);
			}
			
		}, function(res) {
			console.log(res, '失败返回的串');
		});
	}
}(mui, window.myCard = {},document));
//判断是否登陆
if(app.hasToken()){
    myCard.init();
}

