(function ($, owner) {
    owner.category = [];
    owner.childs = [];
    owner.contentList = [];

    //初始化
    owner.init = function () {
        var _this = this;
        _this.getCategoryList();
    }

    //渲染页面
    owner.render = function (list) {
        var _this = this,
            data = {};
        var cateId = app.getQueryString("cateId");
        var cateName = "";
        var contentList = [];
        var childs = [];
        $.each(list,function (i,item) {
            if(item.value == cateId){
                cateName = item.label;
                contentList = item.childs != undefined ? item.childs[0].childs : [];
                childs = item.childs != undefined ? item.childs : [];
            }
        })

        data.list = list;
        data.childs = childs;
        owner.contentList = contentList;
        owner.childs = childs;
        var html = template('business', data);		//一级分类
        var businessTypehtml = template('businessType', data);	//二级分类
        Zepto(".block2al").html(html);
        Zepto(".block2ar").html(businessTypehtml);
        Zepto(".block2ar .contentList ul li").first().addClass("active");

        Zepto("#title1").text(cateName);
        Zepto(".block2al .contentList ul li").each(function (i,item) {
            if(Zepto(this).data("value") == cateId){
                Zepto(this).addClass("active");
            }
        })

        owner.renderContent(contentList);
    }

    //渲染页面
    owner.renderContent = function (list) {
        var _this = this,
            data = {};
        data.contentList = list;
        var html = template('content', data);
        Zepto(".category").html(html);
    }

    
    owner.getCategoryList = function () {
        var list = [];
        app.ajax(app.APP_DOMAIN + '/category/getCategoryList', {}, 'post', function (res) {
            if(res.returnCode == '0000'){
                list = res.resultData.list;
                owner.category = list;
                //成功后重新渲染
                owner.render(list);
                owner.addEvent();
                owner.childEvent();
            }
        })
        return list;
    }

    owner.addEvent = function () {
        Zepto(".block2al .contentList ul li").on('tap', function () {
            var text = Zepto(this).text();
            var value = Zepto(this).data("value");
            Zepto(this).addClass("active").siblings().removeClass("active");
            Zepto(this).parents(".contentList").prev().find("span").text(Zepto(this).text());
            $.each(owner.category, function (i,item) {
                if(item.value == value){
                    var childList = item.childs;
                    var data = {};
                    owner.childs = childList;
                    data.childs = childList;
                    var html = template('businessType', data);
                    Zepto(".block2ar").html(html);

                    var contentList = childList != undefined ? childList[0].childs : [];
                    Zepto(".block2ar .contentList ul li").first().addClass("active");
                    owner.contentList = contentList;
                    owner.renderContent(contentList);
                    owner.childEvent();
                }
            });
        });
    }

    owner.childEvent = function () {
        Zepto(".block2ar .contentList ul li").on('tap', function () {
            var text = Zepto(this).text();
            var value = Zepto(this).data("value");
            Zepto(this).addClass("active").siblings().removeClass("active");
            Zepto(this).parents(".contentList").prev().find("span").text(Zepto(this).text());
            $.each(owner.childs, function (i,item) {
                if(item.value == value){
                    var contentList = item.childs;
                    owner.contentList = contentList;
                    owner.renderContent(contentList);
                }
            });
        })
    }



}(mui, window.category = {}));
//判断是否登陆
if(app.hasToken()){
    category.init();
}
