(function ($, owner) {
    var pageNum = 1, pageSize = 10, isInit = true, isOver = false;
    //初始化
    owner.data = {}

    //渲染页面
    owner.render = function (targetId, sourceId, key, value) {
        var _this = this,
            data = {};
        data[key] = value;
        //渲染数据到页面
        Zepto("#" + targetId).html(template(sourceId, data));
    }

    //消息中心查询
    owner.getALLMessage = function () {
        var _this = this, paraObj = {}, arr = [];
        paraObj.pageNum = pageNum;
        paraObj.pageSize = pageSize;
        app.ajax(app.APP_DOMAIN + '/msgApi/message/all', JSON.stringify(paraObj), 'post', function (res) {
            if (res.responseMessage == "error" && res.responseStatus == "403") {
                mui.toast(res.errorMessage, {duration: 'long', type: 'div'});
            }
            if (res.responseMessage == "success" && res.responseStatus == "200") {
                arr = res.successMessage;
                if (arr.list.length < pageSize) {
                    isOver = true;
                }
                if (isInit) {
                    isInit = false;
                    _this.render('content_view', 'content_script', 'list', arr.list);
                } else {
                    var html = template('content_script', arr);
                    document.getElementById("content_view").innerHTML += html;
                }

                if (isOver == false) {
                    pageNum++;
                }
            }
        })
    }

    //上拉加载
    mui.init({
        pullRefresh: {
            container: '#pullrefresh',
            up: {
                auto: true,
                contentrefresh: '正在加载...',
                callback: pullupRefresh
            }
        }
    });

    function pullupRefresh() {
        setTimeout(function () {
            mui('#pullrefresh').pullRefresh().endPullupToRefresh(isOver); //参数为true代表没有更多数据了。
            if (!isOver) {
                owner.getALLMessage();
            }
        }, 1500);
    }


}(mui, window.msg = {}));
//判断是否登陆
if (app.hasToken()) {
    msg.init();
}