(function ($, owner) {
    //初始化
    owner.data = {}

    owner.getData = function () {
        var announcementsId = app.getQueryString("id");
        if (announcementsId == null || announcementsId == "") {
            mui.toast("消息id获取失败", {duration: 'long', type: 'div'});
            return false;
        }
        this.data.announcementsId = announcementsId;
    }

    owner.init = function () {
        var _this = this;
        _this.getData();
        _this.getDetail();
    }

    //渲染页面
    owner.render = function () {
        var _this = this,
            info = _this.data.info;
        var html = template('body_script', info);
        Zepto("#body_view").html(html);
    }


    //消息详情查询
    owner.getDetail = function () {
        var _this = this;
        var announcementsId = _this.data.announcementsId;
        app.ajax(app.APP_DOMAIN + '/msgApi/message/detail/' + announcementsId, 'messageDetail', 'get', function (res) {
            //console.log(res);
            if (res.responseMessage == "error" && res.responseStatus == "403") {
                mui.toast(res.errorMessage, {duration: 'long', type: 'div'});
            }
            if (res.responseMessage == "success" && res.responseStatus == "200") {
                _this.data.info = res.successMessage;
                _this.render();
            }
        })
    }


}(mui, window.msgDetail = {}));
//判断是否登陆
if (app.hasToken()) {
    msgDetail.init();
}