(function($, owner,document) {
	var sessionTime;
	var count=180;
	var countdown;
	var tel;
	//初始化
	owner.init = function(){
		var self = this;
		self.data={};
		self.data.uuid = window.sessionStorage.getItem("uuid");
		$.init();
		self.addEvents();
		
		//初始化时判断是否可以发送验证码
		self.getSession();
		var now = new Date();
		var minSec =  Math.round((now-sessionTime)/1000);
		if(minSec<count){
			count=count-minSec;
			countdown = setInterval(CountDown, 1000);
		}
		if(tel!=null && typeof(tel)!='undefined'){
			document.getElementById("phone").value=tel;
		}
	}
	
	//获取缓存中存放的发送时间
	owner.getSession=function(){
		var self = this;
		$.ajax({
            type: 'get',
            url: app.APP_DOMAIN+'/registerApi/getSendTime?uuid='+self.data.uuid,
            async:false, 
            headers: {
                'Content-Type':'application/json',
            },
            success: function(res){
            	if(res.sendTime!=null && res.phone!=null){
    				sessionTime = new Date(res.sendTime);
    				tel = res.phone;
    			}else{
    				sessionTime=null;
    			}
            },
            error: function(res){
            	console.log(res,'失败返回的串');
            }
        })
	}
	//倒计时
	CountDown=function() {
		document.getElementById("yzm").classList.remove("on"); 
		document.getElementById("yzm").innerText = "重新发送( " + count + " )";
		
        if (count == 0) {
        	document.getElementById("yzm").classList.add("on");
        	document.getElementById("yzm").innerText = "获取验证码";
        	
            clearInterval(countdown);
            count=180;
        }
        count--;
    }
	
	//校验发送时间
	owner.checkSendTime= function(){
		this.getSession();
		var now = new Date();
		var minSec =  Math.round((now-sessionTime)/1000);
		if(sessionTime==null||minSec>count){
			return true;	
		}
		return false;
	}

	
	//校验手机号
	owner.checkPhone = function(phone){
		if(phone == null || phone == ""){
	    	mui.alert('请输入手机号');
	    	return false;
	    }
		if(!app.checkMobile(phone)){
	    	mui.alert('请输入正确的手机号');
	    	return false;
	    }
		return true;
	}
	
	//校验验证码
	owner.checkPin = function(pin){
		if(pin == null || pin == ""){
	    	mui.alert('请输入验证码');
	    	return false;
	    }
	    var re = /^\d{6}$/ ;
	    if(!re.test(pin)){
		    mui.alert('请输入正确的验证码');
	    	return false;
	    }
	    return true;
	}
	
	
	
	//绑定事件
	owner.addEvents = function(){
		var self = this;
		//获取验证码
		mui(".mui-content").on('tap','.on',function(){
			var phone = document.getElementById("phone").value;
			if(!self.checkPhone(phone)){
				return false;
			}
			if(!self.checkSendTime()){
				return false;
			}
			var paramsObj = {
					UUID:self.data.uuid,
					phone:phone
			};
			countdown = setInterval(CountDown, 1000);//验证码倒计时
			app.ajax(app.APP_DOMAIN+'/registerApi/getPIN',JSON.stringify(paramsObj),'post',function (res) {
	        	if(res.responseStatus == '200'){
	        		console.log(res.successMessage.PIN);
	            	self.data.flg = true;
	        	}else{
	        		//发送失败 停止倒计时  允许重新发送,显示错误信息
	        		document.getElementById("yzm").classList.add("on");
	            	document.getElementById("yzm").innerText = "获取验证码";
	                clearInterval(countdown);
	                count=180;
	                
					$.toast(res.errorMessage);
					self.data.flg = false;
				}
	        },function (res) {
	        	console.log(res,'失败返回的串');
	        });
         });
		//提交(校验验证码)
		mui(".mui-content").on('tap','#next',function(){
			var phone = document.getElementById("phone").value;
			var pin = document.getElementById("pin").value;
			if(!self.checkPhone(phone)){
				return false;
			}
			if(!self.checkPin(pin)){
				return false;
			}
			if(!self.data.flg){
				return false;
			}
			var paramsObj = {
					UUID:self.data.uuid,
					PIN:pin
			};
			app.ajax(app.APP_DOMAIN+'/registerApi/checkPIN',JSON.stringify(paramsObj),'post',function (res) {
	        	if(res.responseStatus == '200'){
	            	//跳转到设置密码页面
	            	app.openWindow(app.APP_DOMAIN+'/registerApi/password','password',true);
	        	}else{
					$.toast(res.errorMessage);
				}
	        },function (res) {
	        	console.log(res,'失败返回的串');
	        });
         });
	}
	
	
	
}(mui, window.pin = {},document));

pin.init();
