(function ($, owner) {
    var TYPE = '1', isInit = true;
    //初始化
    owner.init = function () {
        var _this = this;
        //查询人员信息
        _this.getPersonInfo(isInit);
        //初始化数据
        _this.getInsured();
    }

    //渲染页面
    owner.render = function (targetId, sourceId, key, value) {
        var _this = this,
            data = {};
        data[key] = value;
        //渲染数据到页面
        Zepto("#" + targetId).html(template(sourceId, data));
    }
    //人员信息查询
    owner.getPersonInfo = function () {
        var _this = this;
        var MIInsured = {};
        var dataObj = {};
        app.ajax(app.APP_DOMAIN + '/insured/' + app.rsCode.renYuan, JSON.stringify(dataObj), 'post', function (res) {
            var returnCode = res.returnCode;
            if (returnCode == '0000') {
                console.log(res.resultData);
                MIInsured = res.resultData;
                //单独赋值真是姓名
                MIInsured.realname = res.realname;
                if (isInit) {
                    isInit = false;
                    //调用模板渲染数据到页面
                    _this.render('head_view', 'head_script', 'EIInsured', MIInsured);
                } else {

                }
            } else {
                mui.toast(res.returnMsg);
            }
        })
    }

    //参保查询
    owner.getInsured = function () {
        var _this = this;
        var dataObj = {};
        var dataInsure = {};
        var Insuredlist = [];
        var Insuredlist1 = [];
        var Insuredlist2 = [];
        var Insuredlist3 = [];
        var Insuredlist4 = [];
        var Insuredlist5 = [];
        app.ajax(app.APP_DOMAIN + '/insured/' + app.rsCode.canBao, JSON.stringify(dataObj), 'post', function (res) {
            var returnCode = res.returnCode;
            if (returnCode == '0000') {
                Insuredlist = res.resultData;
                $.each(Insuredlist.jsonlist, function (i, val) {
                    if (val.aae140 == "110" || val.aae140 == "120" || val.aae140 == "130") {
                        Insuredlist1.push(val);
                    } else if (val.aae140 == "210") {
                        Insuredlist2.push(val);
                    } else if (val.aae140 == "310") {
                        Insuredlist3.push(val);
                    } else if (val.aae140 == "410") {
                        Insuredlist4.push(val);
                    } else if (val.aae140 == "510") {
                        Insuredlist5.push(val);
                    }
                });

                dataInsure.Insuredlist1 = Insuredlist1;
                dataInsure.Insuredlist2 = Insuredlist2;
                dataInsure.Insuredlist3 = Insuredlist3;
                dataInsure.Insuredlist4 = Insuredlist4;
                dataInsure.Insuredlist5 = Insuredlist5;
                //渲染完成重新选中tab页面信息
//	              Zepto("#segmentedControl a[data-type='"+TYPE+"']").addClass("mui-active");
                //调用模板渲染数据到页面
                _this.render('content_view', 'content_script', 'dataInsure', dataInsure);
                if(Insuredlist1.length==0){
                    addNoDataAlert("item1");
                }else{
                    clearNoDataAlter();
                }
                if(Insuredlist3.length==0){
                    addNoDataAlert("item2");
                }else{
                    clearNoDataAlter();
                }
                if(Insuredlist4.length==0){
                    addNoDataAlert("item3");
                }else{
                    clearNoDataAlter();
                }
                if(Insuredlist5.length==0){
                    addNoDataAlert("item4");
                }else{
                    clearNoDataAlter();
                }
                if(Insuredlist2.length==0){
                    addNoDataAlert("item5");
                }else{
                    clearNoDataAlter();
                }
            } else {
                mui.toast(res.returnMsg);
            }
        })
    }

    //清空内容渲染
    function clearRenderContent(id) {
        //点击查询清空数据
        Zepto("#"+id).empty();
    }
    //没有数据时增加提示
    function addNoDataAlert(id) {
        Zepto("#"+id).append(app.nullInfoTop45());
    }
    //清空没有数据时候的提示
    function clearNoDataAlter() {
        app.removeNullInfo();
    }
}(mui, window.insured = {}));
mui.init({
    swipeBack: true //启用右滑关闭功能
});
//判断是否登陆
if (app.hasToken()) {
    insured.init();
}