var apply05 = function (mixin) {
  return {
    template: "<div>\n                  <m-element :rules=\"rules\" ref=\"element\">\n                  <div class=\"title\">\u5FEB\u9012\u90AE\u5BC4</div>\n                  \n                  <div class=\"mui-input-group\">\n                      <m-input type=\"textarea\" placeholder=\"\u8BF7\u8F93\u5165\u90AE\u5BC4\u5730\u5740\" label=\"\u90AE\u5BC4\u5730\u5740\" v-model=\"info.recipientAddr\" prop=\"a\"></m-input>\n                      <m-input type=\"number\" placeholder=\"\u8BF7\u8F93\u5165\u90AE\u5BC4\u5730\u5740\" label=\"\u90AE\u653F\u7F16\u7801\" v-model=\"info.pastalCode\" :clearable=\"true\" prop=\"b\"></m-input>\n                  </div>\n                  </m-element>\n                  <div class=\"mui-button-row\">\n                      <button type=\"button\" class=\"mui-btn mui-btn-primary btn\" @tap=\"next\">\u4E0B\u4E00\u6B65</button>\n                  </div>\n                </div>",
    name: 'apply05',
    mixins: [mixin],
    data: function data() {
      return {
        info: {
          recipientAddr: '',
          pastalCode: ''
        },
        rules: {
          a: [{
            required: true,
            message: '邮寄地址 不能为空'
          }],
          b: [{
            required: true,
            message: '邮政编码 不能为空'
          }, {
            min: 5,
            max: 7,
            message: '邮编地址 不正确'
          }]
        }
      };
    },
    methods: {
      next: function next() {
        if (this.$refs['element'].validate(function (vaild) {
          console.log(vaild);

          if (vaild) {
            mui.toast(vaild.message);
            return false;
          }
        })) {
          this.$emit('info0', {
            recipientAddr: this.info.recipientAddr,
            pastalCode: this.info.pastalCode
          });
          this.$router.push('apply06');
        }
      }
    }
  };
}(window.mixin);