
(function ($, owner) {
  //参数
  owner.data = {
    formValue: {}
  }; //初始化

  owner.init = function () {
    this.getUser();
    this.addEvent();
  }; //渲染页面


  owner.render = function (targetId, sourceId, key, value) {
    var _this = this,
        data = {};

    data[key] = value; //渲染数据到页面

    Zepto("#" + targetId).html(template(sourceId, data));
  };

  owner.getUser = function () {
    var that = this;
    app.ajax(app.APP_DOMAIN + '/ucenter/getUserInfo', '', 'get', function (res) {
      if (res.returnCode === '0000') {
        var userInfo = res.resultData;
        that.render('form', 'template', 'user', userInfo);
      }
    }, null, true, {
      'desensitize': 0
    });
  };
  function gotoStatePage(message, success, detail) {
    location.href = 'status.html?message=' + encodeURIComponent(message || '') + '&detail=' + encodeURIComponent(detail || '') + '&type=' + (success ? '1' : '');
  }
  owner.addEvent = function () {
    mui(document.body).on('tap', '.btn', function () {
      app.ajax(app.APP_DOMAIN + '/sscard/reportLost', '', 'get', function (res) {
        if (res.returnCode === '0000')
          gotoStatePage('挂失成功', 1);
        else
          gotoStatePage('挂失失败', 0, res.returnMsg);
      });
    });
  };
})(mui, window.lost01 = {}); //判断是否登陆


if (app.hasToken()) {
  lost01.init();
}