
(function ($, owner) {
  //初始化
  owner.init = function () {
    this.getFollowUp();
  }; //渲染页面


  owner.render = function (targetId, sourceId, key, value) {
    var _this = this,
        data = {};

    data[key] = value; //渲染数据到页面

    Zepto("#" + targetId).html(template(sourceId, data));
  };

  var moment = function moment(d) {
    if (/^(\d{4})(\d{2})(\d{2})$/.test(d)) {
      return RegExp.$1 + '-' + RegExp.$2 + '-' + RegExp.$3;
    }
    return '';
  };

  owner.getFollowUp = function () {
    var that = this;
    app.ajax(app.APP_DOMAIN + '/sscard/followUp', '', 'get', function (res) {
      if (res.returnCode === '0000') {
        var resultData = res.resultData,
            followUp = [],
            item;
        item = {};
        item.title = '申请 / 审核';
        item.start = resultData.applyDate ? moment(resultData.applyDate) : '';
        item.desc = resultData.processResult || '';
        item.status = resultData.processAra017Content || '';
        followUp.push(item);
        item = {};
        item.title = '开户';
        item.start = resultData.are045 ? moment(resultData.are045) : '';
        item.desc = resultData.arc003 || '';
        item.status = resultData.bankara017Content || '';
        followUp.push(item);
        item = {};
        item.title = '制卡';
        item.start = resultData.are048 ? moment(resultData.are048) : '';
        item.desc = resultData.are009 || '';
        item.status = resultData.mkcdara017Content || '';
        followUp.push(item);
        item = {};
        item.title = '个性化';
        item.start = resultData.are057 ? moment(resultData.are057) : '';
        item.desc = resultData.are011 || '';
        item.status = resultData.indiviAra017Content || '';
        followUp.push(item);
        item = {};
        item.title = '完毕';
        item.start = resultData.are053 ? moment(resultData.are053) : '';
        item.noShow = true;
        followUp.push(item);
        var noFlag = followUp.some(function (x) {
          return x.start;
        });

        if (noFlag) {
          that.render('content_view', 'template', 'data', {
            followUp: followUp,
            detail: resultData
          });
        } else {
          Zepto('#content_view').html(app.nullInfo());
        }
      }
    });
  };
})(mui, window.progress01 = {}); //判断是否登陆


if (app.hasToken()) {
  progress01.init();
}