(function($, owner) {
	//参数
	owner.data = {
		
	}
	//初始化
	owner.init = function(){
		var _this = this;
		_this.getData();
		_this.eventListener();
	}
	
	//获取服务器数据
	owner.getData = function(){
		var _this = this;
	    // //this.data.token = sessionStorage.getItem("token");
	    // this.data.token = "3e9ac36f82864d6db9a1d801cfa74de9";
	}
	
	//绑定事件
	owner.eventListener = function(){
		var _this = this;
		mui(document.body).on('tap', '.mui-btn', function(e) {
			if(_this.validate()){
				mui(this).button('loading');
				_this.doSubmit();
			}
		});					    
	}
	//验证
	owner.validate = function(){
		var originalPassword = document.getElementById("originalPassword").value;
		var password = document.getElementById("password").value;
		var confirmPassword = document.getElementById("confirmPassword").value;
	    if(password != confirmPassword){
	    	mui.alert("确认密码与新密码不相同！");
	    	return false;
	    }
	    if(!app.checkPassword(originalPassword)){
	    	mui.alert("请输入6-20位只包含数字字母._的原密码！");
	    	return false;
	    }
	    if(!app.checkPassword(password)){
	    	mui.alert("请输入6-20位只包含数字字母._的新密码！");
	    	return false;
	    }
	    
		this.data.paramsObj = {
			"originalPassword" : originalPassword,
    		"password":password,
    		"confirmPassword" : confirmPassword
		};
		    
		return true;    
	}
	
	//提交
	owner.doSubmit = function(){
		var paramsObj = this.data.paramsObj;
		app.ajax(app.APP_DOMAIN+'/uCenterApi/password/modifyPassword', paramsObj, 'post', function(res){
			console.log(res);
            if(res.responseMessage == "error" && res.responseStatus == "403"){
                mui.toast(res.errorMessage,{ duration:'long', type:'div' });
            }
            if(res.responseMessage == "success" && res.responseStatus == "200"){
                mui.toast("密码修改成功！",{ duration:'long', type:'div' });
                //app.openWindow(app.APP_DOMAIN+'/login','login',true);
            }
			mui('.mui-btn').button('reset');
		})
	}
	
}(mui, window.modifyPassword = {}));

//判断是否登陆
if(app.hasToken()){
    modifyPassword.init();
}