(function($, ucenter) {
    //参数
    ucenter.data = {

    }
    //初始化
    ucenter.init = function(){
        ucenter.addEvent();
        ucenter.getUserInfo();
    };
    //渲染页面
    ucenter.render = function(targetId,sourceId,key,value){
        var _this = this,
            data = {};
        data[key] = value;
        //渲染数据到页面
        Zepto("#"+targetId).html(template(sourceId,data));
    }
    //退出登录
    ucenter.loginOut = function () {
        
    };
    //事件处理
    ucenter.addEvent = function () {

        var _this = this;
        mui(".loginOut").on('tap', '.mui-navigate-right', function() {
            mui.confirm("退出登录，将解除账号绑定","提示信息",['取消', '确定'],function (e) {
                if(e.index == 1 ) {
                    app.ajax(app.APP_DOMAIN_AUTH+'/unbindingUser', '', 'get', function(res){
                    	//解除绑定，删除cookie
                        app.clearAllItem();
                        app.clearCookies();
                        window.location.href = app.APP_DOMAIN_AUTH+'/login/login';
                    });
                }
            },"div");
        });


    };

    //获取用户信息
    ucenter.getUserInfo = function(){
        var _this = this,userInfo = {};
        var now=new Date(),hour=now.getHours();
        userInfo.isAm = hour < 12 ? true : false;
        if(app.getToken == ''){
            userInfo.isLogin = false;
            _this.render('header_view','header_script','userInfo',userInfo);
        }else{
            app.ajax(app.APP_DOMAIN+'/ucenter/getUserInfo', '', 'get', function (res) {
                if(res.returnCode=='0000'){
                    userInfo = res.resultData;
                    userInfo.isLogin = true;
                    _this.render('header_view','header_script','userInfo',userInfo);
                }else{
                    app.clearToken();
                    app.delCookie("token");
                    window.location.href = app.APP_DOMAIN_AUTH + '/login/login';
                    // mui.toast(res.returnMsg);
                }
            })
        }
    }

}(mui, window.ucenterIndex = {}));
//判断是否登陆
if(app.hasToken()){
    ucenterIndex.init();
}